/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package semanticassignment2;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.query.*;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.io.StringWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;


/**
 *
 * @author Thomas
 */
public class RequestHandler {

    Model _model = null;
    String urlOwlString = new String("http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl");
    Boolean _errorConnexion = false;
    
   public RequestHandler() {
   _model = ModelFactory.createOntologyModel();

   try {
     URL url = new URL(urlOwlString);
     InputStream ins = url.openStream();
     // read the RDF/XML file
     _model.read(ins, "");
    }
   catch (MalformedURLException e) {
     e.printStackTrace();
    }
    catch (IOException e) {
     e.printStackTrace();
     _errorConnexion = true;
    }
   }
   
   public Boolean getErrorConnexion() {
       return _errorConnexion;
   }

   //Execute a request an return the result in HTML
   public String[] makeRequest(String request) {
    Query query = QueryFactory.create(request);
    QueryExecution qe = QueryExecutionFactory.create(query, _model);
    ResultSet results = qe.execSelect();    
    String resultXML = ResultSetFormatter.asXMLString(results);
    String stringHTML = new String("");
        try {
            stringHTML = createHTML(resultXML);
        } catch (Exception ex) {
            ex.printStackTrace();
            Logger.getLogger(RequestHandler.class.getName()).log(Level.SEVERE, null, ex);
        }
    qe.close();
    stringHTML = stringHTML.replace("<?xml version=\"1.0\" encoding=\"UTF-8\"?>", " ");
    String[] resultsString = {stringHTML,resultXML};
    return resultsString;
   }
   
    //Create the HTML result, from the xml and the xsl file:
    public String createHTML(String xml) throws Exception{
    TransformerFactory tFactory = TransformerFactory.newInstance();
    StreamSource streamSource = new StreamSource(getClass().getClassLoader().getResourceAsStream("result-to-html.xsl"));
    Transformer transformer = tFactory.newTransformer(streamSource);
    StringWriter swHTML = new StringWriter();
    transformer.transform(new StreamSource(new StringReader(xml)), new StreamResult(swHTML));
    String out = swHTML.getBuffer().toString();
    swHTML.close();
    return out;
    }
   
}
